var allPassLayer=cc.Layer.extend({
    ctor:function(){
        this._super();

        playEffect(res.game_all_pass_1_mp3);
        playEffect(res.game_all_pass_2_mp3);

        cc.spriteFrameCache.addSpriteFrames(res.allpass_plist);

        var winSize = cc.director.getWinSize();


        //背景图
        var bg = new cc.Sprite("#BG.png");
        bg.attr({
            x:winSize.width/2,
            y:winSize.height/2
        });
        this.addChild(bg);

        //标题框
        var banner = new cc.Sprite("#BG_banner.png");
        banner.attr({
            x:bg.width/2,
            y:bg.height,
            anchorY:1
        });
        bg.addChild(banner);

        //失败总次数
        var label=new cc.LabelTTF("失败总次数:  "+ getLoseCount() + "  次    总游戏时长:  "+Math.floor(getGameTime()/3600)+"  小时  "+Math.floor(getGameTime()/60%60)+"  分钟","",20);
        label.attr({x:banner.width/2,y:53.9});
        banner.addChild(label);

        // //总游戏时长
        // var loseTime=new cc.LabelTTF("总游戏时长:  "+"  小时  "+"  分钟  ",70);
        // loseCount.attr({x:134.0,y:53.9});
        // banner.addChild(loseCount);
        // addMove(loseCount)

        //粉红炮
        var spp = new cc.Sprite("#spp2.png");
        spp.attr({x:392.8,y:400.1});
        bg.addChild(spp);

        setAnimation(spp,0.12,["spp1.png","spp2.png","spp3.png","spp4.png","spp5.png"]);

        //绿炮
        var spg = new cc.Sprite("#spg2.png");
        spg.attr({x:858.6,y:346.1});
        bg.addChild(spg);
        setAnimation(spg,0.13,["spg1.png","spg2.png","spg3.png","spg4.png","spg5.png"]);

        //蓝炮
        var spb = new cc.Sprite("#spb2.png");
        spb.attr({x:1014.0,y:328.4});
        bg.addChild(spb);
        setAnimation(spb,0.14,["spb1.png","spb2.png","spb3.png","spb4.png","spb5.png"]);


        //返回主界面
        var homeBtn = createButton("#Button_home.png");
        homeBtn.callback=function()
        {
            stopAllEffect();
            stopBackgroundMusic();

            playEffect(res.BUTTON_SOUNDS);
            cc.director.runScene(new MainScene());

        };
        homeBtn.attr({
            x:bg.width * 1/4,
            y:bg.height * 1/6 - homeBtn.height/2
        });
        bg.addChild(homeBtn);

        cc.log(homeBtn.getContentSize())




        //再玩一次
        var moreGame = createButton("#Button_moreGame.png");
        moreGame.attr({
            x:bg.width *3/4,
            y:bg.height * 1/6 - moreGame.height *1/3
        });
        bg.addChild(moreGame);

        moreGame.callback=function(){
            var blackBg=new cc.LayerColor(cc.color(0,0,0,100));
            bg.parent.addChild(blackBg,10);
            addSwallowTouch(blackBg);

            //重置关卡选择页面
            var resetLevel = new cc.Sprite(res.reset_bg_png);
            resetLevel.attr({
                x:blackBg.width/2,
                y:blackBg.height/2
            });
            blackBg.addChild(resetLevel);
            resetLevel.scale=1.5


            //确认重置关卡
            var resetTrue = createButton(res.reset_btn_ok_png);
            resetTrue.attr({x:268.7,y:77.5});
            resetLevel.addChild(resetTrue);

            resetTrue.callback=function(){
                playEffect(res.BUTTON_SOUNDS);
                initAllData();
                cc.director.runScene(new MainScene());
            };



            //取消重置关卡
            var resetFalse = createButton(res.reset_btn_cancel_png);
            resetFalse.attr( {x:124.9,y:76.8});
            resetLevel.addChild(resetFalse);



            //关闭重置关卡页面
            var resetClose = createButton(res.reset_btn_off_png);
            resetClose.attr({x:365.2,y:160.4});
            resetLevel.addChild(resetClose);


            resetClose.callback=resetFalse.callback=function() {
                blackBg.removeFromParent();
            }
        }.bind(this);


        if(isBaoXiao){
            //挑战框
            isOpenAd("gameAppDownload",function (b) {
                if(b){
                    var nextGame = createButton(res.button_nextGameB4);
                    nextGame.attr({
                        x:bg.width/2 + 10,
                        y:bg.height*1/6 - nextGame.height *3/5
                    });
                    bg.addChild(nextGame);

                    nextGame.callback=function(){
                        if(isMobile()) {
                            var testJSB = new JSB.JSBinding();
                            testJSB.retain();
                            testJSB.openMoreGameToAppStore();
                            testJSB.release();
                        }
                    };
                }
            });
        }else{
            //挑战框
            isOpenAd("gameAppDownload",function (b) {
                if(b){
                    var nextGame = createButton("#button_nextGameK4.png");
                    nextGame.attr({
                        x:bg.width/2 + 10,
                        y:bg.height*1/6 - nextGame.height *3/5
                    });
                    bg.addChild(nextGame);

                    nextGame.callback=function(){
                        if(isMobile()) {
                            var testJSB = new JSB.JSBinding();
                            testJSB.retain();
                            testJSB.openMoreGameToAppStore();
                            testJSB.release();
                        }
                    };
                }
            });
        }

        //史小坑
        var sxk = new cc.Sprite("#sxk1.png");
        sxk.attr({
            x:bg.width/2,
            y:bg.height/2 + sxk.height *1/7
        });
        bg.addChild(sxk);
        setAnimation(sxk,0.16,["sxk1.png","sxk2.png","sxk3.png","sxk4.png","sxk5.png"]);


            //史小坑妹妹
            var xm = new cc.Sprite("#xm_1.png");
            xm.attr({
                x:bg.width *1/3,
                y:bg.height/2 - xm.height *1/4
            });
            bg.addChild(xm);
            setAnimation(xm,0.14,["xm_1.png","xm_2.png","xm_3.png","xm_4.png"]);


            //小青蛙
            var yw = new cc.Sprite("#yw1.png");
            yw.attr({
                x:bg.width *2/3,
                y:bg.height/2 -  yw.height *1/9
            });
            bg.addChild(yw);
            setAnimation(yw,0.1,["yw1.png","yw2.png","yw3.png","yw4.png","yw5.png","yw6.png","yw7.png","yw8.png"]);



        isOpenAd("gameAppDownload",function (b) {
            if(b) {
                //史小坑妹妹：下个游戏推荐
                var nextGameBtn = createButton("#Button_moreGame.png");
                nextGameBtn.attr({x: 444.3, y: 363.9, opacity: 0});
                bg.addChild(nextGameBtn);

                nextGameBtn.callback = function () {
                    if (isMobile()) {
                        var testJSB = new JSB.JSBinding();
                        testJSB.retain();
                        testJSB.openMoreGameToAppStore();
                        testJSB.release();
                    }
                };
            }
        });

        isOpenAd("gameMore",function (b) {
            if (b) {
                //小青蛙：更多游戏
                var moreBtn = createButton("#Button_moreGame.png");
                moreBtn.attr({x: 886.6, y: 401.9, opacity: 0});
                bg.addChild(moreBtn);

                moreBtn.callback = function () {
                    if (isMobile()) {
                        var testJSB = new JSB.JSBinding();
                        testJSB.retain();
                        testJSB.openMoreGameForAndroid();
                        testJSB.release();
                    }
                };
            }
        });



        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                cc.log("begin");
                var target = event.getCurrentTarget();

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    cc.log("sprite began... x = " + locationInNode.x + ", y = " + locationInNode.y);
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                cc.log("end");
            }
        });
        cc.eventManager.addListener(listener1, bg);

    }
});