/**
 * Created by fujiasheng on 14-11-5.
 */

var StoneGameLayer = cc.Layer.extend({


    m_hero:null,
    m_Stones:null,
    m_Listener:null,
    soundid:0,
    score:0,
    ctor:function(){


        this._super();
        cc.spriteFrameCache.addSpriteFrames("res/k35/StonePacker.plist");


        var size = cc.director.getWinSize();
        //设置背景 并 自动填充

        //背景图片
        var bg = cc.Sprite.create("#com_bg_02.png");

        var listener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,
            onTouchBegan: function (touch, event) {
                cc.log("begin");
                var target = event.getCurrentTarget();

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);

                if (cc.rectContainsPoint(rect, locationInNode)) {
                    cc.log("sprite began... x = " + locationInNode.x + ", y = " + locationInNode.y);
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                cc.log("end");
            }
        });
        cc.eventManager.addListener(listener1, this);


        bg.scaleX = size.width/bg.width;
        bg.scaleY = size.height/bg.height;
        bg.x = size.width/2;
        bg.y = size.height/2;
        this.addChild(bg);


        //史小坑
        this.m_hero =  new cc.Sprite("#z_03_man.png");
        this.m_hero.x = size.width/2;
        this.m_hero.y = size.height/2;
        this.m_hero.setScale(0.8);
        this.addChild(this.m_hero,15);
        var ro = cc.rotateBy(3,-360);
        this.m_hero.runAction(cc.repeatForever(ro));

        //背景山
        var mountain = new cc.Sprite("#z_03_mountain.png");
        mountain.attr({
            anchorX:0.5,
            anchorY:0,
            x:size.width/2,
            y:0,
            scaleX:size.width/mountain.width
        });
        this.addChild(mountain);




        //闪电行走区域的宽高，也可以设置史小坑走的区域
        var kuan = size.width; //823;
        var gao = size.height; //613;
        var box_kuan = 732;
        var box_gao = 542;


        var left = cc.p((size.width - kuan)/2.0,size.height/2.0 + gao/2.0);
        var padx = (kuan - box_kuan)/2.0;
        var pady = (gao - box_gao) / 2.0;
        var box_left = cc.p(left.x+padx,left.y-pady);



        //云1
        var cloud1 = new cc.Sprite("#z_03_cloud_1.png");
        cloud1.x = mountain.width * 0.10 * mountain.scaleX;
        cloud1.y = 189;
        this.addChild(cloud1);


        //云1的移动动画
        var c1_mv = cc.moveBy(10.0,cc.p(400* mountain.scaleX,0));
        var c1_s = cc.sequence(c1_mv,c1_mv.reverse());
        cloud1.runAction(cc.repeatForever(c1_s));




        //云2
        var cloud2 = new cc.Sprite("#z_03_cloud_2.png");
        cloud2.x = mountain.width * 0.85* mountain.scaleX ;
        cloud2.y =511;
        this.addChild(cloud2);


        //云2的移动动画
        var c2_mv = cc.moveBy(10.0,cc.p(-500* mountain.scaleX,0));
        var c2_s = cc.sequence(c2_mv,c2_mv.reverse());
        cloud2.runAction(cc.repeatForever(c2_s));

        //存放闪电的容器
        this.m_Stones = this.m_Stones || [];

        for (var i = 0; i < 8; i++) {

            var s = Stone.createStone(kuan, gao, box_kuan, box_gao, left);
            this.addChild(s);
            s.setStart(i+1);
            s.m_maxLuxian = 8;
            s.luxian = i;
            this.m_Stones.push(s);
            var mananimation=new cc.Animation();
            mananimation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_dian_2_1.png"));
            mananimation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_dian_2_2.png"));
            mananimation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_dian_2_1.png"));
            mananimation.setDelayPerUnit(0.05);
            var mananimate=new cc.Animate(mananimation);
            var r = cc.repeat(mananimate,10);
            s.runAction(r);

            this.scheduleOnce(function(){
                playEffect("res/k35/dian_dalei.mp3");
            },i * 0.1 + 0.5);

        }


        this.soundid = playEffect("res/k35/dian_shandian.mp3",true);




        this.scheduleOnce(this.start,2);//两秒后开始





        this.m_listener =  cc.EventListener.create({//触摸监听器
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchMoved:this.onTouchMoved,
            onTouchBegan:this.onTouchBegan,
            onTouchEnded:this.onTouchEnded

        });



        if (cc.sys.capabilities.hasOwnProperty('touches')){//是否可以触屏
            cc.eventManager.addListener(this.m_listener,this);
        }


    },
    onTouchMoved: function (touch, event) {

        var target = event.getCurrentTarget();



        var winSize = cc.director.getWinSize();

        var p = target.m_hero.getPosition();
        if (target.m_hero) {

            p = cc.pAdd(p,touch.getDelta());


            var offset = 75 * 0.8;

            p = cc.pClamp(p, cc.p(offset, offset), cc.p(winSize.width - offset, winSize.height - offset));

            target.m_hero.setPosition(p);
        }


    }, onTouchBegan: function (touch, event) {



        return true;
    }, onTouchEnded: function (touch, event) {


    },
    start:function(dt){//开始


        stopEffect(this.soundid);
        for(var i=0;i< this.m_Stones.length;i++){

            var s = this.m_Stones[i];

            var ro = cc.rotateBy(0.5,-360);
            s.runAction(cc.repeatForever(ro));

        }

        this.scheduleUpdate();

    },
    update:function(dt){

        this.score += dt;

        this.getParent().setScore(this.score.toFixed(1));

        for (var  i = 0; i <this. m_Stones.length; i++) {

            var s = this.m_Stones[i];
            s.move();

            if (s.collision(this.m_hero.getPosition())) {

                //播放史小坑死掉的
                this.m_hero.setTag(playEffect("res/k35/dian_dianji.mp3",true));//点击声
                playEffect("res/k35/dian_dajiao.mp3",false);//大叫
                this.showOverAnimation();
                this.unscheduleAllCallbacks();

                break;
            }
        }
    },

    showOverAnimation:function(){


        cc.eventManager.removeListener(this.m_listener);
        var mananimation=new cc.Animation();
        mananimation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_man_dian_1.png"));
        mananimation.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_man_dian_2.png"));
        mananimation.setDelayPerUnit(0.15);
        var mananimate=new cc.Animate(mananimation);
        var mv = cc.moveBy(0.5,cc.p(0,-this.m_hero.y-100));
        this.m_hero.stopAllActions();
        this.m_hero.runAction(cc.sequence(cc.repeat(mananimate,6),cc.callFunc(function(){

            stopEffect(this.m_hero.getTag());
            this.m_hero.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame("z_03_man_dian_3.png"));// setTexture(cc.textureCache.addImage("#z_03_man_dian_3.png"));

        },this),mv,cc.callFunc(function(){

//            var curLevel;
//            for(var i=0;i<24;i++){
//                if(_arr[i][0]==this.getParent().mainPassionLevel){
//                    curLevel=i+1;
//                }
//            }
            showNormalGameOverPanel(this.getParent(),this.score,this.getParent().mainPassionLevel,2);
            //           this.getParent().lay.gameOver(this.score);

            //在这里处理结束
        },this)));

    }
});

var StoneGameScene=cc.Scene.extend({
    layer:null,
    lay:null,
    score:0,
    fireBomb:null,
    mainPassionLevel:-1,
    _level:-1,
    ctor:function(_mainPassionLevel){
        this._super();
        this.mainPassionLevel = _mainPassionLevel

    },
    onEnter : function() {
        this._super();


        var level = 2;
        _level = level;

        layer =new StoneGameLayer();
        layer.setTag(1);
        this.addChild(layer);

        if(this.fireBomb == null){
            this.fireBomb = new BombFiring(0, this.mainPassionLevel, level);
            this.addChild(this.fireBomb, 1000);
        }


    }
    ,
    pauseTheGame : function () {
        //pause the game
        layer.unscheduleUpdate();
        cc.log("fire_pause the game");
    },
    resumeTheGame :function () {
        //resume the game
        layer.scheduleUpdate();
        cc.log("fire_resume the game");
    },setScore:function(s){

        this.score = s;
//        cc.log(s);
    }

});

var OdlDir = {k_left:1,k_right:2,k_down:3,k_up:4};//由于屏幕是横屏，对在竖屏上的参数的解析
var  Dir = { k_up:1,k_down:2,k_left:3,k_right:4};//正常方向参数
var Go = function(dir,at){
    return {dir:dir,at:at};
};

//控制运动的数据
var runType  = [
    [Go(OdlDir.k_up,7),Go(OdlDir.k_right,2),Go(OdlDir.k_down,5),Go(OdlDir.k_up,2),Go(OdlDir.k_left,8),Go(OdlDir.k_right,5),Go(OdlDir.k_left,8),Go(OdlDir.k_right,5)],
    [Go(OdlDir.k_down,5),Go(OdlDir.k_left,5),Go(OdlDir.k_right,2),Go(OdlDir.k_right,6),Go(OdlDir.k_left,1),Go(OdlDir.k_right,5),Go(OdlDir.k_left,8),Go(OdlDir.k_right,3)],
    [Go(OdlDir.k_up,2),Go(OdlDir.k_left,2),Go(OdlDir.k_down,5),Go(OdlDir.k_right,8),Go(OdlDir.k_down,8),Go(OdlDir.k_right,5),Go(OdlDir.k_left,8),Go(OdlDir.k_down,8)],
    [Go(OdlDir.k_down,5),Go(OdlDir.k_right,5),Go(OdlDir.k_left,8),Go(OdlDir.k_up,10),Go(OdlDir.k_down,5),Go(OdlDir.k_right,5),Go(OdlDir.k_left,8),Go(OdlDir.k_down,3)],
    [Go(OdlDir.k_up,7),Go(OdlDir.k_left,7),Go(OdlDir.k_right,4),Go(OdlDir.k_down,5),Go(OdlDir.k_left,4),Go(OdlDir.k_up,3),Go(OdlDir.k_right,0),Go(OdlDir.k_left,10)],
    [Go(OdlDir.k_up,3),Go(OdlDir.k_right,5),Go(Dir.k_left,6),Go(Dir.k_up,2),Go(Dir.k_right,1),Go(Dir.k_down,8),Go(Dir.k_left,3),Go(Dir.k_right,6)],
    [Go(OdlDir.k_down,7),Go(OdlDir.k_right,7),Go(OdlDir.k_left,4),Go(OdlDir.k_up,5),Go(OdlDir.k_right,4),Go(OdlDir.k_down,3),Go(OdlDir.k_left,0),Go(OdlDir.k_right,10)],
    [Go(OdlDir.k_up,3),Go(OdlDir.k_right,5),Go(Dir.k_left,6),Go(Dir.k_up,2),Go(Dir.k_right,1),Go(Dir.k_down,8),Go(Dir.k_left,3),Go(Dir.k_right,6)]

];


var Stone = cc.Sprite.extend({


    bian:0,
    cout:0,
    item:0,
    cout1:0,
    m_speed:5,
    m_maxLuxian:0,
    targePos:cc.p(0,0),



    maxleft:0,
    maxright:0,
    maxup:0,
    maxdown:0,

    box_maxleft:0,
    box_maxright:0,
    box_maxup:0,
    box_maxdown:0,

    kuan:0,
    gao:0,
    box_kuan:0,
    box_gao:0,
    luxian:0,

    m_radius:0,
    box_radius:0,

    ctor:function (fileName, rect, rotated){

        this._super(fileName, rect, rotated);


    },
    init:function(kuan,gao,box_kuan,box_gao,min_left) {

        this.m_radius = 50*0.5;//60 * 0.9;//闪电

        this.box_radius = 30;//75 * 0.8;//45;//史小坑

        this.box_kuan = box_kuan;

        this.box_gao = box_gao;


        var left = min_left;

        var padx = (kuan - this.box_kuan) / 2.0;
        var pady = (gao - this.box_gao) / 2.0;

        var box_left = cc.p(left.x+padx,left.y-pady);


        this.maxleft = left.x + this.m_radius;
        this.maxright = left.x + kuan - this.m_radius;
        this.maxup = left.y - this.m_radius;
        this.maxdown = left.y - gao + this.m_radius;

        this.kuan = this.maxright-this.maxleft;
        this.gao = this.maxup - this.maxdown;

        this.box_maxleft = box_left.x + this.box_radius;
        this.box_maxright = box_left.x +this.box_kuan - this.box_radius;
        this.box_maxup = box_left.y - this.box_radius;
        this.box_maxdown = box_left.y - this.box_gao + this.box_radius;



        this.bian = 0;

        this.cout = 0;

        this.item = 0;


        this.cout1 = 0;

        this.m_speed = 4;

        this.m_maxLuxian = 0;


    },
    move:function(){



        var pos1 = cc.p(this.x,this.y);

        var k = (this.targePos.y-pos1.y)/(this.targePos.x-pos1.x);


        var x = Math.sqrt(Math.pow(this.m_speed, 2)/(Math.pow(k, 2)+1));//pos1.x - sqrtf(speed/powf(k, 2)+1);

        var pos = cc.p(0,0);
        pos.x =   this.targePos.x-pos1.x > 0 ? pos1.x + x : pos1.x - x;
        pos.y = pos1.y + (pos.x-pos1.x)* k;

        this.x = pos.x;
        this.y = pos.y;

        this.item++;
        if (this.item == this.cout ) {


            playEffect("res/k35/dian_peng.mp3");
            //            MUSIC_TOOL->playEffect("music_66.mp3");//播放小鸟死掉的声音

            while (1) {




                if (this.m_maxLuxian <= 0)
                {



                    cc.log("速度 加 0.5");


                    while (1) {

                        var b = Math.random() * 400;

                        if(b <=100){
                            b = 1;
                        }else if(b <= 200 && b > 100){
                            b = 2;
                        }else if(b <= 300 && b > 200){
                            b = 3;
                        }else{
                            b = 4;
                        }




                        if (b != this.bian) {

                            this.bian = b;
                            break;
                        }
                    }


                    this.targePos = this.createWithId(this.bian, this.rand(0, 10));

                    //                CCAssert(0, "duan");
                }
                else
                {
                    cc.log(this.m_maxLuxian);
                    var a = runType[this.luxian][this.cout1];

                    this.targePos = this.createWithId(a.dir, a.at);

                    this.cout1++;
                    this.m_maxLuxian--;

                    //                CCAssert(cout1 != 5, "duan");
                }

                this.m_speed += 0.2;

                var all =  Math.sqrt(Math.pow(this.targePos.x - this.x,2)+Math.pow(this.targePos.y - this.y,2));


                this.cout = parseInt(all/ this.m_speed);


                this.item = 0;

                if (this.cout != 0) {
                    break;
                }
            }

        }

    },
    setStart:function(start){

        switch (start) {
            case 1:

                this.setPosition(this.createWithId( OdlDir.k_up, 10));
                this.targePos = this.createWithId(OdlDir.k_down, 0);
                this.cout = Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;
            case 2:

                this.setPosition(this.createWithId(OdlDir.k_down, 0));
                this.targePos = this.createWithId(OdlDir.k_up, 10);
                this.cout = Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;
            case 3:

                this.setPosition(this.createWithId(OdlDir.k_up, 0));
                this.targePos = this.createWithId(OdlDir.k_down, 10);
                this.cout = Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            case 4:

                this.setPosition(this.createWithId(OdlDir.k_down, 10));
                this.targePos = this.createWithId(OdlDir.k_up, 0);
                this.cout = Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            case 5:
                this.setPosition(this.createWithId(OdlDir.k_left,3));
                this.targePos=this.createWithId(OdlDir.k_right,7);
                this.cout=Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            case 6:
                this.setPosition(this.createWithId(OdlDir.k_right,3));
                this.targePos=this.createWithId(OdlDir.k_left,7);
                this.cout=Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            case 7:
                this.setPosition(this.createWithId(OdlDir.k_left,7));
                this.targePos=this.createWithId(OdlDir.k_right,3);
                this.cout=Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            case 8:
                this.setPosition(this.createWithId(OdlDir.k_right,7));
                this.targePos=this.createWithId(OdlDir.k_left,3);
                this.cout=Math.sqrt(Math.pow(this.targePos.x - this.getPositionX(),2)+Math.pow(this.targePos.y - this.getPositionY(),2)) / this.m_speed;
                break;

            default:
                break;
        }

        this.cout = parseInt(this.cout);

    },
    collision:function(touchPos){

        var dis = this.box_radius + this.m_radius;

        var pos = this.getPosition();


        var flag = false;




        flag = Math.sqrt(Math.pow(pos.x - touchPos.x,2)+Math.pow(pos.y - touchPos.y,2)) <= dis;

        if (flag) {


            cc.log("在这里碰到火球了");

            return  flag;
        }


        return  flag;


    },
    createWithId:function(bian,at){


        var pos;

        at = (at >= 0 && at <= 10) ? at : 0;

//var OdlDir = {k_left:1,k_right:2,k_down:3,k_up:4}//由于屏幕是横屏，对在竖屏上的参数的解析
        switch (bian)
        {
            case Dir.k_up://1
                pos = cc.p(this.maxleft + this.kuan * 0.1 * at,this.maxup); //上边
                break;
            case Dir.k_down://2

                pos = cc.p(this.maxleft + this.kuan * 0.1 * at,this.maxdown);//下边

                break;
            case Dir.k_left://3

                pos = cc.p(this.maxleft,this.maxdown + this.gao * 0.1 * at);//左边

                break;
            case Dir.k_right://4

                pos = cc.p(this.maxright,this.maxdown + this.gao * 0.1 * at);//右边

                break;

            default:

                pos = cc.p(this.maxleft + this.kuan * 0.1 * at,this.maxup); //默认 上边

                break;
        }

        return pos;

    },

    rand:function(m,n){

        var r = parseInt( Math.random() * (m-n+1)+n);

        return r;


    }

});

Stone.createStone =function(kuan,gao,box_kuan,box_gao,min_left){

    var stone =  new Stone("#z_03_dian_2_1.png");
    stone.setScale(0.5);
    stone.init(kuan,gao,box_kuan,box_gao,min_left);

    return stone;
}
