/**
 * Created by weicheng.li on 14-9-26.
 */

var BikeLayer=cc.Layer.extend({
    winSize:null,
    line:null,
    man:null,
    man_leg:null,
    danceMan:null,
    wheel:null,
    wheel_flag:true,
    wheel_gasFlow:0,
    wheel_type:1,
    man_step:0,
    ride_flag:false,
    down_type:0,
    sound:null,
    sound2:null,
    click_flag:true,
    touch_man_flag:false,
    touch_endPoint_flag:false,
    wheelCurX:0,
    policeMan:null,
    policeMan_eyes:null,
    warning_word:null,
    walk_sound:null,
    ctor:function(){
        this._super();

        this.winSize=cc.director.getWinSize();

        //背景
        var bg=new cc.Sprite("#com_bg_01.png");
        bg.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(bg,-1);

        //群众
        var people=new cc.Sprite("#k_07_people.png");
        people.attr({
            x:this.winSize.width/2-80,
            y:240
        });
        this.addChild(people);

        //草地
        var grass=new cc.Sprite("#com_grassland2.png");
        grass.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(grass);

        //添加云
        var cloud=new cc.Sprite("#com_cloud.png");
        cloud.attr({
            x:this.winSize.width/2-290,
            y:500
        });
        this.addChild(cloud);

        //警卫
        this.policeMan=new cc.Sprite("#k_21_policeman.png");
        this.policeMan.attr({
            x:this.winSize.width/2,
            y:250
        });
        this.addChild(this.policeMan);

        //警卫眼睛
        this.policeMan_eyes=new cc.Sprite("#k_21_policeman_face1.png");
        this.policeMan_eyes.attr({
            x:this.policeMan.getBoundingBox().width/2,
            y:this.policeMan.getBoundingBox().height-67
        });
        this.policeMan.addChild(this.policeMan_eyes);
        var eyesFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_21_policeman_face"+i+".png");
            eyesFrames.push(frame);
        }
        this.policeMan_eyes.runAction(new cc.Animate(new cc.Animation(eyesFrames,0.3)).repeatForever());

        //警卫说话
        this.warning_word=new cc.Sprite("#k_07_huakuang.png");
        this.warning_word.attr({
            x:10,
            y:this.policeMan.getBoundingBox().height+50,
            visible:false
        });
        this.policeMan.addChild(this.warning_word);


        this.policeMan.scale=0.7;

        //终点
        var endPoint=new cc.Sprite("#k_07_win.png");
        endPoint.attr({
            x:this.winSize.width/2+260,
            y:275
        });
        this.addChild(endPoint);

        var endPoint2=new cc.Sprite("#k_07_win2.png");
        endPoint2.attr({
            x:this.winSize.width/2+260+100,
            y:275-29
        });
        this.addChild(endPoint2,3);

        //终点线
        this.line=new cc.Sprite("#k_07_line.png");
        this.line.attr({
            x:endPoint.getBoundingBox().width/2,
            y:157
        });
        endPoint.addChild(this.line,-1);


        //添加车轮
        this.wheel=new cc.Sprite("#k_07_wheel1.png");
        this.wheel.attr({
            x:this.winSize.width/2-300,
            y:145
        });
        this.addChild(this.wheel,2);

        //添加史小坑
        this.man=new cc.Sprite("#k_07_ridebike2_rightleg.png");
        this.man.attr({
            anchorX:0.5,
            anchorY:0,
            x:70,
            y:22
        });
        this.wheel.addChild(this.man);

        //史小坑触摸区域
        var manRect=new cc.LayerColor(cc.color(255,0,0));
        manRect.attr({
            x:this.winSize.width/2-325,
            y:190,
            width:70,
            height:145,
            opacity:0
        });
        this.addChild(manRect);

        //添加脚
        this.man_leg=new cc.Sprite("#k_07_ridebike2_leftleg.png");
        this.man_leg.attr({
            x:71,
            y:131
        });
        this.wheel.addChild(this.man_leg,-1);

        this.rideBike();



        //事件
        var _this=this;

        var listener=cc.EventListener.create({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan:function(touch,event){
                var target=event.getCurrentTarget();
                var location=target.convertToNodeSpace(touch.getLocation());
                var s=target.getBoundingBox();
                var rect=cc.rect(0,0,s.width, s.height);

                if(_this.wheel_flag==true){
                    if(cc.rectContainsPoint(rect,location)){

                        if(_this.sound!=null){
                            stopEffect(_this.sound);
                        }
                        if(_this.wheel_gasFlow<6){
                            _this.sound=playEffect(res.F07_AERATED_SOUNDS);
                        }

                        _this.schedule(_this.aerated,0.4);


                    }
                }

                return true;
            },
            onTouchEnded:function(touch,event){
                _this.unschedule(_this.aerated);
            }
        });

        cc.eventManager.addListener(listener,this.wheel);


        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan:function(touch,event){
                var location=touch.getLocation();

                if(_this.click_flag==true){
                    //点击史小坑
                    if(cc.rectContainsPoint(manRect.getBoundingBox(),location)){
                        _this.click_flag=false;
                        _this.touch_man_flag=true;
                        _this.wheelCurX=_this.wheel.getBoundingBox().x;
                        return true;
                    }

                    //点击终点
                    else if(cc.rectContainsPoint(endPoint.getBoundingBox(),location)){
                        _this.click_flag=false;
                        _this.touch_endPoint_flag=true;
                        return true;
                    }
                }

                return false;
            },
            onTouchMoved:function(touch,event){
                var location=touch.getLocation();
                if(_this.touch_man_flag==true){

                    if(location.x<_this.man.getBoundingBox().width/2){
                        manRect.x=_this.man.getBoundingBox().width/2-25;
                        _this.wheel.x=_this.man.getBoundingBox().width/2;
                    }
                    else if(location.x>endPoint.getPositionX()-50){
                        manRect.x=endPoint.getPositionX()-50-25;
                        _this.wheel.x=endPoint.getPositionX()-50;

                    }else{
                        manRect.x=location.x-25;
                        _this.wheel.x=location.x;
                    }

                    if(_this.wheel.getPositionX() >= endPoint.getPositionX()-51){
                        _this.touch_man_flag=false;
                        _this.wheel_flag=false;
                        _this.Walk();
                        return false;
                    }
                }

                else if(_this.touch_endPoint_flag==true){

                    if(location.x<_this.man.getPositionX()+endPoint.getBoundingBox().width/2){
                        endPoint.x=_this.man.getPositionX()+endPoint.getBoundingBox().width/2;
                        endPoint2.x=_this.man.getPositionX()+endPoint.getBoundingBox().width/2+100;
                    }
                    else if(location.x>_this.winSize.width-endPoint.getBoundingBox().width/2){
                        endPoint.x=_this.winSize.width-endPoint.getBoundingBox().width/2;
                        endPoint2.x=_this.winSize.width-endPoint.getBoundingBox().width/2+100;

                    }else{
                        endPoint.x=location.x;
                        endPoint2.x=location.x+100;
                    }

                    if(endPoint.getPositionX()<=_this.man.getPositionX()+endPoint.getBoundingBox().width/2){
                        _this.touch_endPoint_flag=false;
                        _this.wheel_flag=false;
                        _this.Walk();
                        return false;
                    }
                }
            },
            onTouchEnded:function(touch,event){
                //人物拖动停止
                if(_this.touch_man_flag==true){
                    _this.touch_man_flag=false;
                    if(_this.wheel.getBoundingBox().x >= _this.wheelCurX-10 || _this.wheel.getBoundingBox().x <= _this.wheelCurX+10){
                        _this.wheel_flag=false;
                        _this.rideBike(true);
                        _this.runAction(cc.sequence(
                            cc.callFunc(function(){
                                _this.bikeRight();
                            },this),
                            cc.delayTime(0.2)
                        ).repeatForever());
                    }
                    else if(_this.wheel.getBoundingBox().x >= _this.wheelCurX+70){
                        _this.wheel_flag=false;
                        _this.Walk();
                    }
                    else if(_this.wheel.getBoundingBox().x < _this.wheelCurX+70){
                        _this.wheel.stopAllActions();
                        _this.wheel.runAction(cc.moveTo(0.3,cc.p(_this.winSize.width/2-300,145)));
                        manRect.stopAllActions();
                        manRect.runAction(cc.moveTo(0.3,cc.p(_this.winSize.width/2-300-25,190)));
                        _this.click_flag=true;
                    }
                }

                //终点拖动停止
                else if(_this.touch_endPoint_flag==true){
                    _this.touch_endPoint_flag=false;
                    if(endPoint.getBoundingBox().x-endPoint.getBoundingBox().width/2+95<manRect.getBoundingBox().x){
                        _this.wheel_flag=false;
                        _this.Walk();
                    }
                    else{
                        endPoint.stopAllActions();
                        endPoint.runAction(cc.moveTo(0.3,cc.p(_this.winSize.width/2+260,275)));
                        endPoint2.stopAllActions();
                        endPoint2.runAction(cc.moveTo(0.3,cc.p(_this.winSize.width/2+260+100,275-29)));
                        _this.click_flag=true;
                    }
                }

            }
        },this);
    },
    rideBike:function(bool){    //骑车动作


        this.man.stopAllActions();
        this.man_leg.stopAllActions();
        var animFrames=[];
        animFrames.push(cc.spriteFrameCache.getSpriteFrame("k_07_ridebike2_rightleg.png"));
        animFrames.push(cc.spriteFrameCache.getSpriteFrame("k_07_ridebike_rightleg.png"));
        var animation=new cc.Animation(animFrames,0.3);
        var animate=new cc.Animate(animation);
        this.man.runAction(animate.repeatForever());

        if(bool){
            var animFrames2=[];
            animFrames2.push(cc.spriteFrameCache.getSpriteFrame("k_07_ridebike2_leftleg.png"));
            animFrames2.push(cc.spriteFrameCache.getSpriteFrame("k_07_ridebike_leftleg.png"));
            var animation2=new cc.Animation(animFrames2,0.3);
            var animate2=new cc.Animate(animation2);
            this.man_leg.runAction(animate2.repeatForever());
        }
    },
    aerated:function(){     //打气

        if(this.wheel_flag==true){
            this.wheel_gasFlow++;


            if(this.sound!=null){
                stopEffect(this.sound)
            }
            if(this.wheel_gasFlow<6){
                this.sound=playEffect(res.F07_AERATED_SOUNDS);
            }

            if(this.wheel_gasFlow==2){
                this.wheel.setSpriteFrame("k_07_wheel2.png");
            }

            if(this.wheel_gasFlow==5){
                this.wheel.setSpriteFrame("k_07_wheel3.png");
                this.ride_flag=true;
                this.rideBike(true);
            }
        }
    },
    bikeSound:function(bool){   //骑车音效
        if(this.sound2!=null){
            stopEffect(this.sound2);
        }
        if(bool){
            this.sound2=playEffect(res.F07_WHEEL_SOUNDS);
        }
    },
    bikeRight:function(){   //向右
        this.man_step++;
        this.wheel_type++;
        if(this.wheel_gasFlow<2){   //车轮没气
            if(this.wheel_type%2==0){
                this.wheel.setSpriteFrame("k_07_wheel1_2.png");
            }
            else{
                this.wheel.setSpriteFrame("k_07_wheel1.png");
            }
        }
        else if(this.wheel_gasFlow>=2 && this.wheel_gasFlow<5){  //车轮一半气
            if(this.wheel_type%2==0){
                this.wheel.setSpriteFrame("k_07_wheel2_2.png");
            }
            else{
                this.wheel.setSpriteFrame("k_07_wheel2.png");
            }
        }
        else if(this.wheel_gasFlow>=5){ //车轮满气
            if(this.wheel_type%2==0){
                this.wheel.setSpriteFrame("k_07_wheel3_2.png");
            }
            else if(this.wheel_type%3==0){
                this.wheel.setSpriteFrame("k_07_wheel3_3.png");
            }
            else{
                this.wheel.setSpriteFrame("k_07_wheel3.png");
            }
        }

        var moveX=this.winSize.width/2-300+41*this.man_step;
        this.wheel.stopAllActions();

        this.bikeSound(true);
        this.wheel.runAction(cc.sequence(cc.moveTo(0.2,cc.p(moveX,145)),cc.callFunc(function(){
            this.bikeSound(false);
        },this)));

        if(this.ride_flag==true){
            if(this.man_step>=14){
                this.stopAllActions();
                this.gameWin();
            }
        }
        else if(this.man_step>=5){
            this.stopAllActions();
            this.runAction(cc.sequence(cc.delayTime(0.4),cc.callFunc(this.manDown,this)).repeat(3));
        }
    },
    manDown:function(){     //倒下
        this.man.stopAllActions();
        this.man_leg.stopAllActions();

        this.down_type++;

        var timer=0.4;
        if(this.down_type==1){
            this.man.runAction(cc.spawn(cc.moveTo(timer,cc.p(84,34)),cc.rotateTo(timer,-30)));
        }

        if(this.down_type==2){
            this.man_leg.visible=false;
            this.man.stopAllActions();
            this.man.attr({
                anchorX:1,
                anchorY:0,
                x:40,
                y:15,
                rotation:0
            });
            this.man.setSpriteFrame("k_07_down.png");
        }
        if(this.down_type==3){
            this.man.setSpriteFrame("k_07_down2.png");
            this.man.attr({
                x:0,
                y:-15,
                rotation:0
            });

            playEffect(res.F07_JIAO);

            this.gameOver(1);
        }
    },
    Walk:function(){  //警察走路
        this.policeMan.setLocalZOrder(4);
        this.wheel.setLocalZOrder(5);
        this.policeMan.setSpriteFrame("k_21_policeman_walk_1.png");
        this.policeMan_eyes.stopAllActions();
        this.policeMan_eyes.visible=false;
        var walkFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_21_policeman_walk_"+i+".png");
            walkFrames.push(frame);
        }
        this.policeMan.runAction(new cc.Animate(new cc.Animation(walkFrames,0.2)).repeatForever());

        var walk_sound;

        this.policeMan.runAction(cc.sequence(
            cc.spawn(
                cc.flipX(true),
                cc.scaleTo(1,1),
                cc.moveTo(1,cc.p(this.wheel.getBoundingBox().x+150,220)),
                cc.callFunc(function(){
                    this.walk_sound=playEffect(res.F21_Walk,true);
                },this)
            ),
            cc.callFunc(function(){
                this.Warning();
            },this)
        ));
    },
    Warning:function(){ //警察警告
        stopEffect(this.walk_sound);
        this.policeMan.stopAllActions();
        this.policeMan_eyes.visible=true;
        this.policeMan_eyes.setSpriteFrame("k_21_policeman_face3.png");
        this.policeMan.setSpriteFrame("k_21_policeman.png");
        this.policeMan.scaleX=-1;
        this.policeMan.flippedX=false;
        this.warning_word.visible=true;
        this.warning_word.flippedX=true;
        this.warning_word.setPosition(cc.pAdd(this.warning_word.getPosition(),cc.p(100,0)));
        playEffect(res.F21_FindOut);

        this.runAction(cc.sequence(
            cc.delayTime(1),
            cc.callFunc(function(){
                this.man.stopAllActions();
                this.man_leg.stopAllActions();
                this.man.setSpriteFrame("k_07_ridebike_qianzou.png");
                this.man_leg.setSpriteFrame("k_07_ridebike_leftleg.png");
                playEffect(res.F07_HENG);
            },this),
            cc.delayTime(1),
            cc.callFunc(function(){
                this.Strike();
            },this)
        ))
    },
    Strike:function(){  //警察打人
        this.policeMan_eyes.visible=false;
        this.warning_word.visible=false;
        this.policeMan.setSpriteFrame("k_21_policeman_bite_1.png");
        this.policeMan.runAction(cc.sequence(
            cc.delayTime(0.5),
            cc.callFunc(function(){
                this.policeMan.setSpriteFrame("k_21_policeman_bite_2.png");
                playEffect(res.F11_MANHIT_SOUNDS);
                this.man_leg.visible=false;
                this.man.setSpriteFrame("k_11_man_fly.png");
                this.man.runAction(cc.sequence(
                    cc.spawn(
                        cc.scaleTo(0.6,2),
                        cc.moveBy(0.6,cc.p(-15,-70))
                    ),
                    cc.callFunc(function(){
                        this.man.setSpriteFrame("k_11_man_stick.png");
                        this.man.scale=1;
                        this.runAction(cc.sequence(
                            cc.moveTo(0.075,cc.p(-10,-10)),
                            cc.moveTo(0.15,cc.p(10,10)),
                            cc.moveTo(0.075,cc.p(0,0))
                        ));
                    },this),
                    cc.place(this.man.getPositionX(),this.man.getPositionY()-150),
                    cc.moveBy(1,cc.p(0,-100)),
                    cc.callFunc(function(){
                        this.gameOver();
                    },this)
                ))
            },this)
        ));
    },
    Dance:function(){   //跳舞
        playEffect(res.F07_DANCE_SOUNDS);

        //如花
        this.danceMan=new cc.Sprite("#k_23_jump1.png");
        this.danceMan.attr({
            x:this.winSize.width/2-100,
            y:220
        });
        this.addChild(this.danceMan);


        var animFrames=[];
        for(var i=1;i<=9;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_23_jump"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.3);
        var animate=new cc.Animate(animation);
        this.danceMan.runAction(animate.repeatForever());

    },
    gameOver:function(type){
        this.wheel_flag=false;
        this.ride_flag=false;
        this.click_flag=false;

        this.runAction(cc.sequence(cc.delayTime(1),cc.callFunc(function(){
            type=type || 0;
            ShowFaildPPanel(this.getParent(),7,type);
        },this)));

    },
    gameWin:function(){
        this.wheel_flag=false;
        this.ride_flag=false;
        this.click_flag=false;

        this.line.setSpriteFrame("k_07_line2.png");

        var txt=new cc.Sprite("#k_07_wenzi.png");
        txt.attr({
            x:this.winSize.width/2-110,
            y:400
        });
        this.addChild(txt,2);

        this.Dance();

        this.runAction(cc.sequence(cc.delayTime(4),cc.callFunc(function(){
            ShowSuccessPanel(this.getParent(),7);
        },this)));
    }

});

var BikeScene=cc.Scene.extend({
    layer:null,
    onEnter:function(){
        this._super();
        this.layer=new BikeLayer();
        this.addChild(this.layer);

        var level=7;
        var mainUILayer=new MainUILayer(level);
        this.addChild(mainUILayer,2);
    },
    pauseTheGame : function () {
        //pause the game
        this.layer.unscheduleAllCallbacks();
    },
    resumeTheGame :function () {
        //resume the game/
    }
});