/**
 * Created by weicheng.li on 14-9-25.
 */

var DodgeLayer=cc.Layer.extend({
    status:1,
    winSize:null,
    stone:null,
    man:null,
    man_hand:null,
    spider:null,
    boxes:null,
    boxes_cover:null,
    bomb:null,
    bomb_wire1:null,
    bomb_wire2:null,
    bomb_wire3:null,
    bomb_off:null,
    bomb_time:null,
    time:5,
    boxes_flag:false,
    click_flag:false,
    bomb_flag:false,
    win_flag:false,
    sound:null,
    poison_flag:false,
    moon:null,
    ctor:function(){
        this._super();

        this.winSize=cc.director.getWinSize();

        //背景
        var bg=new cc.Sprite("#com_bg_02.png");
        bg.attr({
            x:this.winSize.width/2,
            y:0,
            anchorX:0.5,
            anchorY:0
        });
        this.addChild(bg,-1);

        //土地
        var tudi=new cc.Sprite("#com_tudi.png");
        tudi.attr({
            x:this.winSize.width/2,
            y:0,
            anchorX:0.5,
            anchorY:0
        });
        this.addChild(tudi,-1);

        //月亮
        this.moon=new cc.Sprite("#k_19_moon.png");
        this.moon.attr({
            x:this.winSize.width/2+200,
            y:470
        });
        this.addChild(this.moon);

        //山
        var mountain=new cc.Sprite("#k_09_stone_mountain.png");
        mountain.attr({
            x:this.winSize.width/2,
            y:0,
            anchorX:0.5,
            anchorY:0
        });
        this.addChild(mountain,-1);

        //石头
        this.stone=new cc.Sprite("#k_09_stone_little.png");
        this.stone.attr({
            x:this.winSize.width/2-43,
            y:130
        });
        this.addChild(this.stone);

        //蜘蛛
        this.spider=new cc.Sprite("#k_09_spider_1.png");
        this.spider.attr({
            anchorX:0.5,
            anchorY:1,
            x:this.winSize.width/2-320,
            y:370
        });
        this.addChild(this.spider,2);

        //史小坑
        this.man=new cc.Sprite("#k_09_man_lie_down.png");
        this.man.attr({
            x:this.winSize.width/2-70,
            y:85
        });
        this.addChild(this.man);

        //手
        this.man_hand=new cc.Sprite("#k_09_hand_1.png");
        this.man_hand.attr({
            x:60,
            y:71
        });
        this.man.addChild(this.man_hand);

        //手动画
        var animFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_09_hand_"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.3);
        var animate=new cc.Animate(animation);
        this.man_hand.runAction(animate.repeatForever());


        //宝箱
        this.boxes=new cc.Sprite("#k_09_boxes.png");
        this.boxes.attr({
            x:this.winSize.width/2+135,
            y:140
        });
        this.addChild(this.boxes);

        //宝箱盖
        this.boxes_cover=new cc.Sprite("#k_09_boxes_cover_1.png");
        this.boxes_cover.attr({
            x:133,
            y:172
        });
        this.boxes.addChild(this.boxes_cover);


        //炸弹
        this.bomb=new cc.Sprite("#k_14_boomboom.png");
        this.bomb.attr({
            x:this.winSize.width/2+125,
            y:215,
            rotation:5,
            visible:false
        });
        this.bomb.setVisible(false);
        this.addChild(this.bomb,3);

        //炸弹线
        this.bomb_wire1=new cc.Sprite("#k_14_wire_01.png");
        this.bomb_wire1.attr({
            x:130,
            y:107
        });
        this.bomb.addChild(this.bomb_wire1);

        this.bomb_wire2=new cc.Sprite("#k_14_wire_02.png");
        this.bomb_wire2.attr({
            x:120,
            y:50
        });
        this.bomb.addChild(this.bomb_wire2);

        this.bomb_wire3=new cc.Sprite("#k_14_wire_03.png");
        this.bomb_wire3.attr({
//            x:118,
//            y:32
            x:95,
            y:21,
            rotation:5
        });
        this.bomb.addChild(this.bomb_wire3);

        //炸弹时间
        this.bomb_time=new cc.LabelAtlas("05",res.k_14_number, 48, 64, ' ');
        this.bomb_time.attr({
            x:46,
            y:55,
            color:cc.color(247,32,48),
            scale:0.5,
            rotation:-5
        });
        this.bomb.addChild(this.bomb_time);

        //炸弹开关
        this.bomb_off=new cc.Sprite("#k_09_off_1.png");
        this.bomb_off.attr({
            x:this.bomb.getBoundingBox().x+82,
            y:this.bomb.getBoundingBox().y+122,
            visible:false
        });
        this.addChild(this.bomb_off,3);

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ALL_AT_ONCE,
            onTouchesBegan:function(touches,event){
                var target=event.getCurrentTarget();
                var location=touches[0].getLocation();

                if(target.status!=0){
                    if(cc.rectContainsPoint(target.spider.getBoundingBox(),location)){
                        var rotate1=cc.rotateTo(0.2,-10);
                        var rotate2=cc.rotateTo(0.4,10);
                        var rotate3=cc.rotateTo(0.2,0);

                        target.spider.stopAllActions();
                        target.spider.runAction(cc.sequence(rotate1,rotate2,rotate3).repeatForever());
                        target.spider.runAction(cc.spawn(
                            cc.scaleTo(0.6,0.7),
                            cc.jumpTo(0.6,cc.p(target.winSize.width/2-195,290),150,1)
                        ));

                        if(!target.poison_flag){

                            target.poison_flag=true;
                            target.manAfraid();
                            target.runAction(cc.sequence(
                                cc.delayTime(1),
                                cc.callFunc(function(){
                                    if(target.status!=0){
                                        target.Poisoning();
                                    }
                                },target)
                            ));
                        }
                    }

                    if(cc.rectContainsPoint(target.moon.getBoundingBox(),location)){
                        target.Blind();
                    }
                }


                if(cc.rectContainsPoint(target.stone.getBoundingBox(),location)){
                    target.stone.stopAllActions();
                    target.stone.runAction(cc.spawn(cc.scaleTo(0.1,1.2),cc.sequence(cc.rotateTo(0.1,15),cc.rotateTo(0.2,-15),cc.rotateTo(0.1,0),cc.scaleTo(0.05,1))));
                    return;
                }

                if(target.boxes_flag==false && target.status!=0){
                    if(cc.rectContainsPoint(target.boxes.getBoundingBox(),location)){
                        target.boxes_flag=true;
                        target.openBoxes();
                        return;
                    }
                }
                else if(target.click_flag==true){
                    if(cc.rectContainsPoint(target.bomb_off.getBoundingBox(),location)){
                        target.click_flag=false;
                        target.bomb_off.setSpriteFrame("k_09_off_2.png");
                        target.BombBomb();
                        return;
                    }
                    else if(cc.rectContainsPoint(target.bomb.getBoundingBox(),location)){
                        target.bomb_flag=true;
                        return true;
                    }
                }
                return false;
            },
            onTouchesEnded:function(touches,event){
                var target=event.getCurrentTarget();
                if(target.bomb_flag==true){
                    target.BombBomb();
                }
            }
        },this);

        var _this=this;

        cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function(){
            if(_this.boxes_flag==true){
                _this.win_flag=true;
            }
        });

        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(){
            if(_this.win_flag==true && _this.status==1){
                _this.gameWin();
            }
        });


    },
    manAfraid:function(){
        this.man_hand.stopAllActions();
        this.man_hand.setVisible(false);

        this.man.stopAllActions();

        playEffect(res.F09_JINGXIA);

        this.man.setSpriteFrame("k_09_man_afraid.png");
        this.man.attr({
            x:this.winSize.width/2-200,
            y:165
        });
        this.man.runAction(cc.sequence(
            cc.moveBy(0.3,cc.p(15,0)),
            cc.moveBy(0.3,cc.p(-15,0)),
            cc.moveBy(0.3,cc.p(-15,0)),
            cc.moveBy(0.3,cc.p(15,0))
        ).repeatForever());
    },
    manAfraid2:function(){
        this.man_hand.stopAllActions();
        this.man_hand.setVisible(false);

        this.man.stopAllActions();

        playEffect(res.F09_YUN);

        this.man.setSpriteFrame("k_09_man_yun.png");
        this.man.attr({
            x:this.winSize.width/2-200,
            y:165
        });
        this.man.runAction(cc.sequence(
            cc.moveBy(0.3,cc.p(10,-3)),
            cc.moveBy(0.3,cc.p(-10,-3)),
            cc.moveBy(0.3,cc.p(-10,3)),
            cc.moveBy(0.3,cc.p(10,3))
        ).repeatForever());

        var eyes1=new cc.Sprite("#k_09_yun_2.png");
        eyes1.attr({
            x:this.man.getBoundingBox().width/2-5,
            y:this.man.getBoundingBox().height-33,
            scale:0.8
        });
        this.man.addChild(eyes1);
        eyes1.runAction(cc.rotateBy(3,360).repeat(2));

        var eyes2=new cc.Sprite("#k_09_yun_2.png");
        eyes2.attr({
            x:this.man.getBoundingBox().width/2+13,
            y:this.man.getBoundingBox().height-33,
            scale:0.8
        });
        this.man.addChild(eyes2);
        eyes2.runAction(cc.sequence(
            cc.rotateBy(3,360),
            cc.callFunc(function(){
                this.man.stopAllActions();
                this.man.attr({
                    rotation:-90,
                    x:this.man.getBoundingBox().x+70,
                    y:this.man.getBoundingBox().y
                });
            },this),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                ShowFaildPPanel(this.getParent(),9);
            },this)
        ));


    },
    openBoxes:function(){

        this.click_flag=true;

        this.scheduleOnce(this.manAfraid,0.2);

        this.boxes_cover.setSpriteFrame("k_09_boxes_cover_2.png");
        this.boxes_cover.attr({
            x:232,
            y:207
        });

        playEffect(res.F09_OPENBOXES_SOUNDS);

        this.bomb.visible=true;

        this.bomb_off.visible=true;

        this.bomb_time.runAction(cc.sequence(cc.fadeIn(0.5),cc.delayTime(0.2),cc.fadeOut(0.3)).repeatForever());

        this.runAction(cc.sequence(cc.delayTime(1),cc.callFunc(this.timeStep,this)).repeatForever());
    },
    timeStep:function(){
        if(this.time>0){
            this.time--;
            var time=this.time>9?this.time:"0"+this.time;
            this.bomb_time.setString(time);

            if(this.sound!=null){
                stopEffect(this.sound);
            }
            this.sound=playEffect(res.F09_TIME_SOUNDS);

        }else{
            this.BombBomb();
        }

    },
    BombBomb:function(){    //爆炸

        this.gameOver();

        this.bomb_wire1.visible=false;
        this.bomb_wire2.visible=false;
        this.bomb_wire3.visible=false;
        this.bomb_time.visible=false;
        this.bomb_off.visible=false;

        this.bomb.setSpriteFrame("com_boom_02.png");
        this.bomb.attr({
            x:this.winSize.width/2,
            y:this.winSize.height/2-50,
            scale:2.5
        });
        var animFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("com_boom_0"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.2);

        this.bomb.runAction(cc.sequence(new cc.Animate(animation).repeat(2),cc.callFunc(function(){
            ShowFaildPPanel(this.getParent(),9,2);
        },this)));

        var layerColor=new cc.LayerColor(cc.color(255,255,255,150));

        layerColor.runAction(cc.sequence(cc.blink(0.4,5),cc.callFunc(function(){
            layerColor.removeFromParent();
        },this)));

        this.addChild(layerColor,10);

        this.man.attr({
            rotation:-90,
            x:this.man.getBoundingBox().x+70,
            y:this.man.getBoundingBox().y
        });

        stopEffect(this.sound);

        playEffect(res.F09_BOMB_SOUNDS);
    },
    Poisoning:function(){   //中毒

        this.gameOver();

        playEffect(res.F09_SPIDER);

        this.man.setSpriteFrame("k_09_man_zhongdu_3.png");

        var animFrames=[];
        for(var i=1;i<=3;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_09_man_zhongdu_"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.3);
        var animate=new cc.Animate(animation);
        this.man.runAction(cc.sequence(
            animate,
            cc.callFunc(function(){
                this.man.attr({
                    rotation:-90,
                    x:this.man.getBoundingBox().x+70,
                    y:this.man.getBoundingBox().y
                });
            },this),
            cc.delayTime(1.5),
            cc.callFunc(function(){
                ShowFaildPPanel(this.getParent(),9,1);
            },this)
        ));
    },
    Blind:function(){   //闪光

        this.gameOver();

        playEffect(res.F09_MOON_LIGHT);

        var shine_moon=new cc.Sprite("#k_09_shine_moon.png");
        shine_moon.attr({
            x:this.moon.getBoundingBox().x+50,
            y:this.moon.getBoundingBox().y+50
        });
        this.addChild(shine_moon,-1);

        shine_moon.runAction(cc.rotateBy(10,720).repeatForever());
        shine_moon.runAction(cc.sequence(cc.delayTime(3),cc.scaleTo(1.5,1.5),cc.scaleTo(1.5,1)).repeatForever());


        var layerColor=new cc.LayerColor(cc.color(255,255,255,150));

        layerColor.runAction(cc.sequence(cc.blink(1.5,6),cc.callFunc(function(){
            layerColor.removeFromParent();
            this.manAfraid2();
        },this)));

        this.addChild(layerColor,10);



    },
    gameOver:function(){
        this.stopAllActions();

        this.status=0;

        this.click_flag=false;
        this.bomb_flag=false;

        this.man.stopAllActions();

    },
    gameWin:function(){
        this.stopAllActions();
        this.man.stopAllActions();

        this.man.setSpriteFrame("k_09_man_smile.png");
        if(cc.sys.os!="Android"){
            stopEffect(this.sound);
            playEffect(res.F22_XIAO);
            playEffect(res.F09_COIN_LIGHT);
        }

        var smile=new cc.Sprite("#k_09_smile.png");
        smile.attr({
            x:this.man.getBoundingBox().width/2-3,
            y:this.man.getBoundingBox().height-45
        });
        this.man.addChild(smile);
        smile.runAction(cc.sequence(cc.moveBy(0.1,cc.p(0,1.5)),cc.moveBy(0.1,cc.p(0,-1.5))).repeatForever());


        this.status=0;
        this.click_flag=false;
        this.bomb_flag=false;
        this.bomb.visible=false;
        this.bomb_off.visible=false;


        var gold=new cc.Sprite("#k_09_shine_gold.png");
        gold.attr({
            x:120,
            y:120
        });
        this.boxes.addChild(gold);
        gold.runAction(cc.rotateBy(0.5,30).repeatForever());

        this.runAction(cc.sequence(cc.delayTime(2.5),cc.callFunc(function(){
            ShowSuccessPanel(this.getParent(),9);
        },this)));
    }
});

var DodgeScene=cc.Scene.extend({
    layer:null,
    onEnter:function(){
        this._super();
        this.layer=new DodgeLayer();
        this.addChild(this.layer);

        var level=9;
        var mainUILayer=new MainUILayer(level);
        this.addChild(mainUILayer,2);
                               
//                               alert(_arr)
    },
    pauseTheGame : function () {
        //pause the game
    },
    resumeTheGame :function () {
        //resume the game
    }
});