/**
 * Created by weicheng.li on 14-9-24.
 */

var MoneyboxLayer=cc.Layer.extend({
    winSize:null,
    pig:null,
    tail:null,
    lock:null,
    click_flag:true,
    shake_flag:false,
    move_flag:true,
    shakeCnt:0,
    shakeCount:0,
    sound:null,
    _pages:[],
    page_flag:true,
    clock_flag:true,
    scream:null,
    ctor:function(){
        this._super();

        this.winSize=cc.director.getWinSize();

        var bg=new cc.Sprite("#com_bg_01.png");
        bg.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(bg,-1);

        //桌子
        var desk=new cc.Sprite("#k_17_bg.png");
        desk.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(desk);

        //时钟
        var clock=new cc.Sprite("#k_17_clock.png");
        clock.attr({
            x:this.winSize.width/2-270,
            y:480
        });
        this.addChild(clock);

        var clock_needles1=new cc.Sprite("#k_17_needles_01.png");
        clock_needles1.attr({
            x:clock.getBoundingBox().width/2,
            y:clock.getBoundingBox().height/2
        });
        clock.addChild(clock_needles1);
        clock_needles1.runAction(cc.rotateBy(1,6).repeatForever());

        var clock_needles2=new cc.Sprite("#k_17_needles_02.png");
        clock_needles2.attr({
            x:clock.getBoundingBox().width/2,
            y:clock.getBoundingBox().height/2
        });
        clock.addChild(clock_needles2);
        clock_needles2.runAction(cc.rotateBy(1,60).repeatForever());


        //日历
        var calendar=new cc.Sprite("#k_17_calendar.png");
        calendar.attr({
            x:this.winSize.width/2-270,
            y:300
        });
        this.addChild(calendar);


        for(var i=3;i>0;i--){
            var Page=new cc.Sprite("#k_17_page_0"+i+".png");
            Page.attr({
                x:this.winSize.width/2-270,
                y:300
            });
            this.addChild(Page);
            this._pages.push(Page);
        }


        //尾巴
        this.tail=new cc.Sprite("#k_17_tail_01.png");
        this.tail.attr({
            x:this.winSize.width/2+335,
            y:430
        });
        this.addChild(this.tail);

        //猪钱罐
        this.pig=new cc.Sprite("#k_17_pig_01.png");
        this.pig.attr({
            x:this.winSize.width/2+90,
            y:350
        });
        this.addChild(this.pig);

        var pig_eyes=new cc.Sprite("#k_17_eyes_01.png");
        pig_eyes.attr({
            x:this.pig.getBoundingBox().width/2-100,
            y:this.pig.getBoundingBox().height/2+70
        });
        this.pig.addChild(pig_eyes);
        var animFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_17_eyes_0"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,1);
        var animate=new cc.Animate(animation);
        pig_eyes.runAction(animate.repeatForever());

        //吃惊
        this.scream=new cc.Sprite("#k_17_scream.png");
        this.scream.attr({
            x:30,
            y:this.pig.getBoundingBox().height-15,
            visible:false
        });
        this.pig.addChild(this.scream);


        var _this=this;

        //密码锁
        this.lock=new cc.ControlPotentiometer("#k_17_numbers.png", "#k_17_numbers.png" , "#k_17_needle.png");
        this.lock.attr({
            x:this.winSize.width/2+175,
            y:353
        });
        this.addChild(this.lock);

        var money=new cc.Sprite("#k_17_money.png");
        money.attr({
            x:this.winSize.width/2-170,
            y:30
        });
        this.addChild(money);

        _this=this;

        this.lock.addTargetWithActionForControlEvents(this,function(sender){
            if(_this.move_flag==true){
                if(_this.sound!=null){
                    stopEffect(_this.sound);
                }
                _this.sound=playEffect(res.F17_NEEDLE);

                _this.shake_flag=false;

                _this.stopAllActions();
                _this.runAction(cc.sequence(cc.delayTime(1),cc.callFunc(function(){
                    _this.gameOver();
                },_this)));
            }
        }, cc.CONTROL_EVENT_VALUECHANGED);

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ALL_AT_ONCE,
            onTouchesBegan:function(touches,event){
                var target=event.getCurrentTarget();
                var location=touches[0].getLocation();

                if(target.click_flag==true){
                    if(target.shake_flag==false){
                        if(cc.rectContainsPoint(target.tail.getBoundingBox(),location)){
                            target.shake_flag=true;
                            pig_eyes.visible=false;
                            target.pig.setSpriteFrame("k_17_pig_02.png");
                            target.tail.setSpriteFrame("k_17_tail_02.png");

                            target.scream.visible=true;
                            target.scream.runAction(cc.sequence(
                                cc.delayTime(1),
                                cc.callFunc(function(){
                                    target.scream.visible=false;
                                },target)
                            ));


                            playEffect(res.F17_PIG_SOUNDS);
                            return false;
                        }
                    }else if(target.shake_flag==true){
                        if(cc.rectContainsPoint(target.tail.getBoundingBox(),location)) {
                            target.shake_flag = false;
                            pig_eyes.visible = true;
                            target.scream.visible = false;
                            target.scream.stopAllActions();
                            target.pig.setSpriteFrame("k_17_pig_01.png");
                            target.tail.setSpriteFrame("k_17_tail_01.png");
                            return false;
                        }
                    }
                }

                if(cc.rectContainsPoint(money.getBoundingBox(),location)){
                    money.stopAllActions();
                    money.runAction(cc.sequence(
                        cc.scaleTo(0.3,1.3),
                        cc.moveTo(0.6,cc.p(money.getBoundingBox().x,-100)),
                        cc.callFunc(function(){
                            money.visible=false;
                        },target))
                    );
                }

                if(cc.rectContainsPoint(clock.getBoundingBox(),location)){
                    if(!target.clock_flag){
                        target.clock_flag=true;
                        clock_needles1.runAction(cc.rotateBy(1,6).repeatForever());
                        clock_needles2.runAction(cc.rotateBy(1,60).repeatForever());
                    }else{
                        target.clock_flag=false;
                        clock_needles1.stopAllActions();
                        clock_needles2.stopAllActions();
                    }
                }

                if(target._pages.length>0  && target.page_flag==true){
                    if(cc.rectContainsPoint(target._pages[target._pages.length-1].getBoundingBox(),location)){

                        target.page_flag=false;

                        var Act=new cc.Sprite("#k_17_act_04.png");
                        Act.attr({
                            x:target.winSize.width/2-270,
                            y:300
                        });

                        target.addChild(Act);

                        var animFrames=[];
                        for(var i=1;i<=4;i++){
                            var frame=cc.spriteFrameCache.getSpriteFrame("k_17_act_0"+i+".png");
                            animFrames.push(frame);
                        }
                        var animation=new cc.Animation(animFrames,0.2);
                        var animate=new cc.Animate(animation);
                        Act.runAction(animate);
                        Act.runAction(cc.sequence(
                            cc.delayTime(0.6),
                            cc.callFunc(function(){
                                target._pages[target._pages.length-1].removeFromParent();
                                target._pages.splice(target._pages.length-1,1);
                                Act.setLocalZOrder(-1);
                                target.page_flag=true;
                            },target)
                        ));

                        playEffect(res.F17_PAGE);
                    }
                }
                return false;
            }
        },this);

        cc.inputManager.setAccelerometerInterval(1/30);    //加速计的时间间隔
        cc.inputManager.setAccelerometerEnabled(true);    //加速计开关
        cc.eventManager.addListener({
            event: cc.EventListener.ACCELERATION,
            callback: function(acc, event){
                var x=acc.x;
                var y=acc.y;
                var z=acc.z;
                var all= x*x + y*y + z*z;

                if(_this.shake_flag==true){
                    if(x<-0.2){
                        _this.unscheduleAllCallbacks();
                        if(all<1.5){
                            if (_this.shakeCnt>2) {
                                _this.shakeCount++;
                                if(_this.shakeCount>2){
                                    _this.gameWin();
                                }
                            }
                            _this.shakeCnt=0;
                        }else if (all>1.6){
                            _this.shakeCnt++;
                        }
                    }else{
                        _this.scheduleOnce(function(){
                            _this.shakeCnt=0;
                            _this.shakeCount=0;
                        },0.3);
                    }
                }
            }
        }, this);

    },
    gameOver:function(){

        this.click_flag=false;
        this.move_flag=false;

        var bomb=new cc.Sprite("#com_boom_02.png");
        bomb.attr({
            x:this.winSize.width/2,
            y:this.winSize.height/2,
            scale:2.5
        });
        this.addChild(bomb,5);

        var animFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("com_boom_0"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.2);
        bomb.runAction(cc.sequence(new cc.Animate(animation).repeat(2),cc.callFunc(function(){
            ShowFaildPPanel(this.getParent(),17);
        },this)));

        var layerColor=new cc.LayerColor(cc.color(255,255,255,150));

        layerColor.runAction(cc.sequence(cc.blink(0.4,5),cc.callFunc(function(){
            layerColor.removeFromParent();
        },this)));

        this.addChild(layerColor,10);


        playEffect(res.F09_BOMB_SOUNDS);

    },
    gameWin:function(){
        this.move_flag=false;
        this.click_flag=false;
        this.shake_flag=false;
        this.stopAllActions();

        var random_count=Math.round(Math.random()*8)+5;
        for(var i=0;i<random_count;i++){
            var random_x=Math.round(Math.random()*180)-90;
            var random_y=Math.round(Math.random()*60)-20;
            var random_rotation=Math.round(Math.random()*16)-8;
            var coin=new cc.Sprite("#k_17_coin.png");
            coin.attr({
                x:this.winSize.width/2-100,
                y:280,
                rotation:random_rotation
            });
            this.addChild(coin);
            coin.runAction(cc.sequence(
                cc.moveTo(0.2+i*0.05,cc.p(this.winSize.width/2-200+random_x,200+random_y)),
                cc.callFunc(function(){
                    playEffect(res.F17_COIN);
                },this)
            ));
        }


        this.runAction(cc.sequence(cc.delayTime(3),cc.callFunc(function(){
            ShowSuccessPanel(this.getParent(),17);
        },this)));
    }
});

var MoneyboxScene=cc.Scene.extend({
    onEnter:function(){
        this._super();
        var layer=new MoneyboxLayer();
        this.addChild(layer);

        var level=17;
        var mainUILayer=new MainUILayer(level);
        this.addChild(mainUILayer,2);
    },
    pauseTheGame : function () {
        //pause the game
    },
    resumeTheGame :function () {
        //resume the game
    }
});