/**
 * Created by weicheng.li on 14-11-08.
 */

var FillingLayer = cc.Layer.extend({
    status:1,
    winSize:null,
    click_flag:true,
    bingo_flag:false,
    move_flag:false,
    _numBtns:[],
    man:null,
    question:null,
    lbText:null,
    ctor : function() {
        this._super();

        this.winSize=cc.director.getWinSize();


        var bg=new cc.Sprite("#com_bg_01.png");
        bg.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(bg,-1);

        var ground=new cc.Sprite("#com_grassland2.png");
        ground.attr({
            anchorX:0.5,
            anchorY:0,
            x:this.winSize.width/2,
            y:0
        });
        this.addChild(ground,-1);

        //厕所
        var toilet=new cc.Sprite("#k_18_toilet.png");
        toilet.attr({
            x:this.winSize.width/2-170,
            y:180
        });
        this.addChild(toilet);

        //人
        this.man=new cc.Sprite("#k_18_man_01.png");
        this.man.attr({
            x:this.winSize.width/2-225,
            y:205
        });
        this.addChild(this.man);

        var manFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_18_man_0"+i+".png");
            manFrames.push(frame);
        }
        var animation=new cc.Animation(manFrames,0.3);
        var animate=new cc.Animate(animation);
        this.man.runAction(animate.repeatForever());

        //问号
        this.question=new cc.Sprite("#k_18_question_01.png");
        this.question.attr({
            x:this.winSize.width/2-220,
            y:323
        });
        this.addChild(this.question);

        var questionFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_18_question_0"+i+".png");
            questionFrames.push(frame);
        }
        var animation2=new cc.Animation(questionFrames,0.3);
        var animate2=new cc.Animate(animation2);
        this.question.runAction(animate2.repeatForever());


        //草丛
        var grass1=new cc.Sprite("#k_18_grass_01.png");
        grass1.attr({
            anchorX:1,
            anchorY:0,
            x:this.winSize.width/2-380,
            y:0
        });
        this.addChild(grass1);

        var grass2=new cc.Sprite("#k_18_grass_02.png");
        grass2.attr({
            anchorX:0,
            anchorY:0,
            x:this.winSize.width/2+400,
            y:0
        });
        this.addChild(grass2);

        //云
        var cloud=new cc.Sprite("#home_cloud.png");
        cloud.attr({
            x:this.winSize.width/2-400,
            y:480
        });
        this.addChild(cloud);

        var cloud2=new cc.Sprite("#home_cloud.png");
        cloud2.attr({
            x:this.winSize.width/2+515,
            y:325
        });
        this.addChild(cloud2);

        //面板
        var framePanel=new cc.Sprite("#k_18_frame.png");
        framePanel.attr({
            x:this.winSize.width/2+150,
            y:270
        });
        this.addChild(framePanel);

        //空
        var kongRect=new cc.LayerColor(cc.color(255,0,0,0));
        kongRect.attr({
            width:50,
            height:50,
            x:this.winSize.width/2-62,
            y:449,
            opacity:0
        });
        this.addChild(kongRect,1);

        var kong=new cc.LabelTTF("空",getFONT_FZCY_M03SStr(),26);
        kong.attr({
            x:kongRect.getBoundingBox().width/2,
            y:kongRect.getBoundingBox().height/2,
            color:cc.color(168,66,43),
            opacity:0
        });
        kongRect.addChild(kong);

        //数字文本框
        this.lbText=new cc.LabelTTF("",getFONT_FZCY_M03SStr(),45,cc.size(140,60),cc.TEXT_ALIGNMENT_CENTER);
        this.lbText.attr({
            x:this.winSize.width/2+190,
            y:379,
            color:cc.color(73,50,38)
        });
        this.addChild(this.lbText);

        var lbTextRect=new cc.LayerColor(cc.color(255,255,255,0));
        lbTextRect.attr({
            x:this.winSize.width/2+125,
            y:357,
            width:140,
            height:40,
            opacity:0
        });
        this.addChild(lbTextRect);


        //数字按钮

        this._numBtns=[];

        for(var i=0;i<3;i++){
            for(var j=0;j<3;j++){
                var number=i*3+j+1;
                var numBtn=new cc.Sprite("#k_18_btn_number_frame_01.png");
                numBtn.attr({
                    x:this.winSize.width/2+50+j*100,
                    y:300-i*75
                });
                this.addChild(numBtn);

                var numBtn_word=new cc.LabelTTF(number,getFONT_FZCY_M03SStr(),50);
                numBtn_word.attr({
                    x:numBtn.getBoundingBox().width/2-3,
                    y:numBtn.getBoundingBox().height/2+10,
                    color:cc.color(73,50,38)
                });
                numBtn.addChild(numBtn_word);

                this._numBtns.push(numBtn);
            }
        }

        //确定按钮
        var confirmBtn=new cc.Sprite("#k_18_btn_sure_frame_01.png");
        confirmBtn.attr({
            x:this.winSize.width/2+70,
            y:76
        });
        this.addChild(confirmBtn);

        var confirmBtn_word=new cc.LabelTTF("确定",getFONT_FZCY_M03SStr(),32);
        confirmBtn_word.attr({
            x:confirmBtn.getBoundingBox().width/2,
            y:confirmBtn.getBoundingBox().height/2+3,
            color:cc.color(73,50,38)
        });
        confirmBtn.addChild(confirmBtn_word);

        //回删按钮
        var clearBtn=new cc.Sprite("#k_18_btn_sure_frame_01.png");
        clearBtn.attr({
            x:this.winSize.width/2+230,
            y:76
        });
        this.addChild(clearBtn);

        var clearBtn_word=new cc.LabelTTF("回删",getFONT_FZCY_M03SStr(),32);
        clearBtn_word.attr({
            x:clearBtn.getBoundingBox().width/2,
            y:clearBtn.getBoundingBox().height/2+3,
            color:cc.color(73,50,38)
        });
        clearBtn.addChild(clearBtn_word);


        var _this=this;
        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan:function(touch,event){
                var loaction=touch.getLocation();

                if(_this.click_flag==true && _this.status!=0){
                    for(var i=0;i<_this._numBtns.length;i++){
                        if(cc.rectContainsPoint(_this._numBtns[i].getBoundingBox(),loaction)){
                            cc.log("numBtn:"+numBtn);
                            playEffect(res.F13_Touch);
                            _this.click_flag=false;
                            _this._numBtns[i].setSpriteFrame("k_18_btn_number_frame_02.png");
                            var numBtnText=_this._numBtns[i].getChildren()[0];
                            numBtnText.attr({
                                x:_this._numBtns[i].getBoundingBox().width/2+2,
                                y:_this._numBtns[i].getBoundingBox().height/2+5
                            });

                            if(_this.lbText.getString().length<6) {
                                _this.lbText.setString(_this.lbText.getString() + numBtnText.getString());
                            }

                            if(_this.bingo_flag==true){
                                _this.bingo_flag=false;
                                kongRect.runAction(cc.place(_this.winSize.width/2-62,449));
                                kongRect.getChildren()[0].opacity=0;
                            }
                            return true;
                        }
                    }

                    if(cc.rectContainsPoint(confirmBtn.getBoundingBox(),loaction)){
                        playEffect(res.F13_Touch);
                        _this.click_flag=false;
                        confirmBtn.setSpriteFrame("k_18_btn_sure_frame_02.png");
                        var confirmBtnText=confirmBtn.getChildren()[0];
                        confirmBtnText.attr({
                            x:confirmBtn.getBoundingBox().width/2+5,
                            y:confirmBtn.getBoundingBox().height/2-2
                        });

                        if(_this.bingo_flag==true){
                            _this.gameWin();
                        }else{
                            _this.gameOver();
                        }

                        return true;
                    }

                    if(cc.rectContainsPoint(clearBtn.getBoundingBox(),loaction)){
                        playEffect(res.F13_Touch);
                        _this.click_flag=false;
                        clearBtn.setSpriteFrame("k_18_btn_sure_frame_02.png");
                        var clearBtnText=clearBtn.getChildren()[0];
                        clearBtnText.attr({
                            x:clearBtn.getBoundingBox().width/2+5,
                            y:clearBtn.getBoundingBox().height/2-2
                        });

                        if(_this.lbText.getString().length>0){
                            _this.lbText.setString(_this.lbText.getString().substring(0,_this.lbText.getString().length-1));
                        }
                        return true;
                    }

                    if(cc.rectContainsPoint(kongRect.getBoundingBox(),loaction)){
                        if(!_this.move_flag){
                            _this.move_flag=true;
                            _this.bingo_flag=false;
                            kongRect.getChildren()[0].opacity=255;
                        }
                        cc.log("move:OK");
                        return true;
                    }
                }

                return false;
            },
            onTouchMoved:function(touch,event){
                if(_this.move_flag==true){
                    var delta=touch.getDelta();
                    kongRect.x+=delta.x;
                    kongRect.y+=delta.y;
                }
            },
            onTouchEnded:function(touch,event){

                if(_this.status!=0){
                    _this.click_flag=true;
                }

                for(var i=0;i<_this._numBtns.length;i++){
                    _this._numBtns[i].setSpriteFrame("k_18_btn_number_frame_01.png");
                    var numBtnText=_this._numBtns[i].getChildren()[0];
                    numBtnText.attr({
                        x:_this._numBtns[i].getBoundingBox().width/2-3,
                        y:_this._numBtns[i].getBoundingBox().height/2+10
                    });
                }

                confirmBtn.setSpriteFrame("k_18_btn_sure_frame_01.png");
                var confirmBtnText=confirmBtn.getChildren()[0];
                confirmBtnText.attr({
                    x:confirmBtn.getBoundingBox().width/2,
                    y:confirmBtn.getBoundingBox().height/2+3
                });

                clearBtn.setSpriteFrame("k_18_btn_sure_frame_01.png");
                var clearBtnText=clearBtn.getChildren()[0];
                clearBtnText.attr({
                    x:clearBtn.getBoundingBox().width/2,
                    y:clearBtn.getBoundingBox().height/2+3
                });

                if(_this.move_flag==true){
                    _this.move_flag=false;
                    if(cc.rectIntersectsRect(kongRect.getBoundingBox(),lbTextRect.getBoundingBox())){
                        kongRect.stopAllActions();
                        if(_this.lbText.getString().length==0){
                            kongRect.runAction(cc.moveTo(0.3,cc.p(_this.winSize.width/2+170,350)));
                            _this.bingo_flag=true;
                        }
                        else{
                            kongRect.runAction(cc.place(_this.winSize.width/2-62,449));
                            kongRect.getChildren()[0].opacity=0;
                        }
                    }
                    else{
                        kongRect.runAction(cc.place(_this.winSize.width/2-62,449));
                        kongRect.getChildren()[0].opacity=0;
                    }
                }
            }
        },framePanel);
    },
    gameOver:function(){
        this.status=0;
        this.click_flag=false;

        var bomb=new cc.Sprite("#com_boom_02.png");
        bomb.attr({
            x:this.winSize.width/2,
            y:this.winSize.height/2,
            scale:2.5
        });
        this.addChild(bomb,5);

        var animFrames=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("com_boom_0"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.2);
        bomb.runAction(cc.sequence(new cc.Animate(animation).repeat(2),cc.callFunc(function(){
            ShowFaildPPanel(this.getParent(),18);
        },this)));

        var layerColor=new cc.LayerColor(cc.color(255,255,255,150));

        layerColor.runAction(cc.sequence(cc.blink(0.4,5),cc.callFunc(function(){
            layerColor.removeFromParent();
        },this)));

        this.addChild(layerColor,10);


        playEffect(res.F09_BOMB_SOUNDS);

    },
    gameWin:function(){
        this.status=0;
        this.click_flag=false;

        //人物动画
        this.man.stopAllActions();
        this.man.setSpriteFrame("k_18_man_win_01.png");
        var animFrames=[];
        for(var i=2;i<=7;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_18_man_win_0"+i+".png");
            animFrames.push(frame);
        }
        var animation=new cc.Animation(animFrames,0.15);
        var animate=new cc.Animate(animation);
        this.man.runAction(cc.sequence(cc.delayTime(0.15),animate,cc.delayTime(0.25)).repeatForever());

        //马桶塞
        var toilet_plug=new cc.Sprite("#k_18_toilet_plug.png");
        toilet_plug.attr({
            x:this.winSize.width/2-250,
            y:this.winSize.height/2-130
        });
        this.addChild(toilet_plug);
        toilet_plug.runAction(cc.spawn(cc.rotateTo(0.1,30),cc.moveBy(0.1,cc.p(-100,-100))));

        //符号动画
        this.question.stopAllActions();
        this.question.setSpriteFrame("k_18_blink_01.png");
        this.question.attr({
            x:this.winSize.width/2-190,
            y:283
        });

        var animFrames2=[];
        for(var i=1;i<=2;i++){
            var frame=cc.spriteFrameCache.getSpriteFrame("k_18_blink_0"+i+".png");
            animFrames2.push(frame);
        }
        var animation2=new cc.Animation(animFrames2,0.2);
        var animate2=new cc.Animate(animation2);
        this.question.runAction(animate2.repeatForever());

        //盖章
        var chapter=new cc.Sprite("#k_18_chapter.png");
        chapter.attr({
            x:this.winSize.width/2+100,
            y:this.winSize.height/2,
            scale:2.5
        });
        this.addChild(chapter,2);

        chapter.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(0.3,1),
                cc.MoveBy(0.3,cc.p(210,-40))
            ),
            cc.callFunc(function(){
                playEffect(res.F24_seal)
            },this),
            cc.delayTime(2),
            cc.callFunc(function(){
                ShowSuccessPanel(this.getParent(),18);
            },this)
        ));
    }
});

var FillingScene = cc.Scene.extend({
   onEnter : function()
   {
       this._super();
       var layer = new FillingLayer();
       this.addChild(layer);

       var level = 18;
       var mainUILayer = new MainUILayer(level);
       this.addChild(mainUILayer, 2);
   },
    pauseTheGame : function () {
        //pause the game
        cc.log("pause the game");
    },
    resumeTheGame :function () {
        //resume the game
        cc.log("resume the game");
    }

});